unit PhloXLib;
{$IFDEF FPC}{$PACKENUM 1}{$MODE Delphi}{$ENDIF}
interface

type
  {$IFNDEF FPC}
  dword=cardinal;
  pdword=^dword;
  {$ENDIF}
  PInputs=^TInputs;
  PShortEffect=^TShortEffect;

  PEasySprite=^TEasySprite;
  PTexturedPatternSprite=^TTexturedPatternSprite;
  PSpriteEx=^TSpriteEx;
  PAnimSprite=^TAnimSprite;
  PUserObject=^TUserObject;
  PSpriteContainer=^TSpriteContainer;

  TObjectRenderProc=procedure(self:pointer);stdcall;

  //<GUI types>
  PGUISprite=^TGUISprite;
  PFont=^TFont;
  PCursorSprite=^TCursorSprite;
  PTextSprite=^TTextSprite;
  PButtonSprite=^TButtonSprite;
  PSliderSprite=^TSliderSprite;
  PMemoSprite=^TMemoSprite;
  PListSprite=^TListSprite;
  PPHXLLinkObject=^TPHXLLinkObject;

  TButtonState=(bsNormal,bsDown,bsEnabled,bsDisabled);
  TButtonChanges=(bchEnable,bchDisable,bchMouseDown,bchMouseUp);
  TCursorChanges=(cchDown,cchUp,cchDClick,cchMove);
  TButtonType=(btStandart,btCheckBox);
  TSliderType=(stSlider,stProgress,stSliderProgress);
  TPHXLTextUpdateMode=(tumOverride,tumAppend,tumInsert,tumDelete);

  TButtonChangesProc=procedure(state:TButtonChanges);stdcall;
  TSliderChangesProc=procedure(position:byte);stdcall;
  TCursorChangesProc=procedure(cur:PCursorSprite);stdcall;
  TMemoChangesProc=function(key:dword;memo:PMemoSprite):boolean;stdcall;
  TListChangesProc=procedure(item:dword;list:PListSprite);stdcall;
  //</GUI types>
  //<geometry types>
  TVector2d = array[0..1] of double;
  TVector2f = array[0..1] of single;
  TVector2i = array[0..1] of longint;
  TVector2s = array[0..1] of smallint;
  TVector2b = array[0..1] of byte;
  TVector2e = array[0..1] of Extended;
  TVector2w = array[0..1] of Word;
  TVector2p = array[0..1] of Pointer;

  TVector3d = array[0..2] of double;
  TVector3f = array[0..2] of single;
  TVector3i = array[0..2] of longint;
  TVector3s = array[0..2] of smallint;
  TVector3b = array[0..2] of byte;
  TVector3e = array[0..2] of Extended;
  TVector3w = array[0..2] of Word;
  TVector3p = array[0..2] of Pointer;

  TVector4d = array[0..3] of double;
  TVector4f = array[0..3] of single;
  TVector4i = array[0..3] of longint;
  TVector4s = array[0..3] of smallint;
  TVector4b = array[0..3] of byte;
  TVector4e = array[0..3] of Extended;
  TVector4w = array[0..3] of Word;
  TVector4p = array[0..3] of Pointer;
  //</geometry types>

  TAlphaTest=(atAll,atPrecision,atMask);
  TSpriteType=(stEasySprite,stTexturedPatternSprite,stSpriteEx,stAnimSprite,
                  stUserObject,stCursorSprite,stTextSprite,stButtonSprite,stSliderSprite,
                  stMemoSprite,stListSprite,stSpriteContainer);
  TCPUCompressionQuality=(l0,l1,l2,l3,l4,l5,l6,l7,l8,l9);
  TTextureMode=(tmDecal,tmModulate,tmBlend,tmReplace);
  TTextureFilter=(tfLinear,tfNearest,tfMMLinear,tfMMNearest);
  TTextureCompressionQuality=(tcqNone,tcqRGB_DXT1,tcqRGBA_DXT1,tcqRGBA_DXT3,tcqRGBA_DXT5);
  TEffectType=(etHalo,etFire,etFireEx,etParticles,etBlur,etThor,etTail);
  TShortEffectType=(setUser,setFade,setShake);
  TParentSpriteType=(pstEasySprite,pstSpriteEx,pstAnimSprite,pstUserObject);
  
  TParticlesProc=procedure(particles:pointer; length,time:dword; var added_particle_pointer:dword);stdcall;
  TUserProc=procedure(data:dword;she:PShortEffect);stdcall;
  TPHXLTimer_proc=procedure(delta_time:cardinal);stdcall;
  
  TPHXLProcType=(ptClient_wnd_proc,ptRender_proc,ptInputs_proc,ptClose_func,ptKeyboard_proc,ptMouseMove_proc,ptMousePress_proc,ptMouseRelease_proc);
  TPHXLMouseButton=(mbLeft,mbRight,mbMiddle);
  TClient_wnd_proc=procedure(msg,wparam,lparam:dword);stdcall;
  TInputs_proc=procedure(delta_time:cardinal);stdcall;
  TRender_proc=procedure(ind:byte);stdcall;
  TClose_func=function(can_cancel:boolean):boolean;stdcall;
  TKeyboard_proc=procedure(key:word;keydown:boolean);stdcall;
  TMouseMove_proc=procedure(x,y:word);stdcall;
  TMousePress_proc=procedure(button:TPHXLMouseButton);stdcall;
  TMouseRelease_proc=TMousePress_proc;       
  
  TPhXLPoint=record
    x,y:single;
  end;
  TPhXLVector=TPhXLPoint;
  TPhXLRect=record
    x,y,w,h:single;
  end;
  TPhXLRect2=record
    left,top,right,bottom:single;
  end;

  TInputs=record
   keyboard:array [0..255] of Byte;
   btn0,btn1,btnM:boolean;
   mx,my:word;
  end;

  TPHXLLinkObject=record
    _VMT:pointer;
    previous,next:PPHXLLinkObject;
    //destructor Destroy;virtual;
  end;

  TPHXLTimer=record
   _VMT:pointer;
   previous,next:PPHXLLinkObject;
   proc:TPHXLTimer_proc;
   worked:boolean;
   time,deltat:cardinal;
  end;
  PPHXLTimer=^TPHXLTimer;

  TOutPort=record
    x,y,w,h:integer;
    index:byte;
    sleep:word;
    left,right,bottom,top:Double;
    min_z,max_z:byte;
    worked:boolean;
    fps,var_frames,var_time,var_time2,new_time,delta_time:dword;
  end;
  POutPort=^TOutPort;

  PTexture=^TTexture;

     TParticle=record
       position,xy_speed,xy_acceleration,width_height:TPhXLPoint;
       scale,scale_speed,angle,angle_speed:single;
       color1,color2:TVector4f;
       life_time,birth_time,frame:dword;
       enabled:boolean;
     end;
     PParticle=^TParticle;

     TThorPart=record
       elements:array of single;
       max_element_index:dword;
       glow_width,vibration,core_with:single;
       direct,line_smooth:boolean;
     end;

     TEffect=record
       render_first,generate,x_random,y_random,particle_attenuation:boolean;
       effect_type:TEffectType;
       parts_count,frame_count:dword;
       particles:array of TParticle;
       radius,length,angle,particle_radius,scale_speed:single;
       position,xy_speed:TPhXLPoint;
       life_time,interval,time:dword;
       color1,color2:TVector4f;
       texture:PTexture;
       added_particle_pointer:dword;
       arr_beam_coords:array of TPhXLPoint;
       user_proc1,user_proc2:pointer;
       arr_thor_parts:array of TThorPart;
     end;
     PEffect=^TEffect;

     TShortEffect=record
       effect_type:TShortEffectType;
       time,birth_time,duration,interval,freq:dword;
       render_first,enabled,random:boolean;
       onProgress,onStop:TUserProc;
       user_data:dword;
       color1,color2:TVector4f;
       rect:TPhXLRect2;
       point:TPhXLPoint;
       s1,s2,s3,s4:single;
     end;

     TEasySprite=record
      SpriteType:TSpriteType;
      render_proc:TObjectRenderProc;
      pp:pointer;
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
     end;

     TTexturedPatternSprite=record
      SpriteType:TSpriteType;
      render_proc:TObjectRenderProc;
      pp:pointer;
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
      angle:single;
      x1,y1,x2,y2,x3,y3,x4,y4:single;
      engine_calc:boolean;
      color:TVector4f;
      tex1,tex2,tex3,tex4:TVector2f;
     end;

     TSpriteEx=record
      SpriteType:TSpriteType;
      render_proc:TObjectRenderProc;
      pp:pointer;
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
      angle:single;
      x1,y1,x2,y2,x3,y3,x4,y4:single;
      engine_calc:boolean;
      gradient,lines:boolean;
      color1,color2:TVector4f;
      linesWidth:single;
      tex_x,tex_y,tex_w,tex_h:single;
     end;

     TAnimSprite=record
      SpriteType:TSpriteType;
      render_proc:TObjectRenderProc;
      pp:pointer;
      x,y,w,h:single;
      z:byte;
      texture:PTexture;
      effects_enable:boolean;
      effects:array [0..2] of PEffect;
      angle:single;
      x1,y1,x2,y2,x3,y3,x4,y4:single;
      engine_calc:boolean;
      color:TVector4f;
      frames_hor,frames_vert,curr_frame,frame_count:word;
      frame_time:integer;
      first_frame,last_frame:word;
      anim_type:(atLoopForward,atLoopBack,atOneForward,atOneBack,atNone);
      time:dword;
     end;

     TUserObject=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,w,h:single;
       z:byte;
       effects_enable:boolean;
       effects:array [0..2] of PEffect;
       angle:single;
       data:dword;
       user_render_proc:TObjectRenderProc;
     end;

     POwnedSprite=^TOwnedSprite;
     TOwnedSprite=record
       sprite:pointer;
       next:POwnedSprite;
     end;

     TSpriteContainer=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,scale_x,scale_y:single;
       z:byte;
       sprites:POwnedSprite;
       modal:boolean;
       angle:single;
       gui_form_enable:boolean;
       gui_drag_area:TPhXLRect2;
       mx,my:single;
     end;

     TGUISprite=record//abstract "parent" type for buttons, listboxes, memo, sliders (and text - for compatibility with buttons)
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,ch_w,ch_h:single;
       z:byte;
       text:PChar;
       modal:boolean;
     end;

     TFont=record
       texture:PTexture;
       char_first,char_last:word;
       chars_hor,chars_vert:word;
       tex_ch_w,tex_ch_h:single;
       chars_coord_arr_length:word;
       chars_coord:PChar;
     end;

     TCursorSprite=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,w,h:single;
       z:byte;
       texture:PTexture;
       effects_enable:boolean;
       effects:array [0..2] of PEffect;
       angle:single;
       frames_hor,frames_vert,curr_frame,frame_count:word;
       frame_time:integer;
       first_frame,last_frame:word;
       time:dword;
       visible:boolean;
       enabled:boolean;
       proc:TCursorChangesProc;
       last_change:TCursorChanges;
     end;

     TTextSprite=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,ch_w,ch_h:single;
       z:byte;
       text:PChar;
       modal:boolean;//for compatibility text operations with PButtonSprite (not used)
       font:PFont;
       text_length:longint;
       text_width:single;
       dx,dy:single;
       color1,color2:TVector4f;
       blink_time:word;
       blink_var:longint;
       centered:boolean;
     end;

     TButtonSprite=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,ch_w,ch_h:single;
       z:byte;
       text:PChar;
       modal:boolean;
       font:PFont;
       text_length:longint;
       text_width:single;
       dx,dy:single;
       texture:PTexture;
       state_count:byte;
       state:TButtonState;
       proc_change:TButtonChangesProc;
       b_type:TButtonType;
       w,h:single;
       color1,color2:TVector4f;
       enabled:boolean;
       combo_list:pointer;//PListSprite
     end;

     TSliderSprite=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,w,h:single;
       z:byte;
       texture:PTexture;
       modal:boolean;
       RatioParts:byte;//only for stProgress stSliderProgress
       position_border,ScrollerScale:single;//only for stSlider type
       position:byte;
       dynamic_part_tex_border:single;
       vertical:boolean;
       sl_type:TSliderType;
       proc_change:TSliderChangesProc;
       controlled_control:PUserObject;//PMemoSprite or PListSprite
       dynamic_part_first:boolean;
       enabled:boolean;
     end;
     
     TMemoSprite=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,w,h:single;
       z:byte;
       text:PChar;
       modal:boolean;
       font:PFont;
       ch_w,ch_h,vert_scroll:single;
       chars_dx,chars_dy:single;
       text_length,buffer_length:cardinal;
       texture:PTexture;
       brdWidth,brdHeight:single;
       multistrings,editable,cursor:boolean;
       cursor_pos,max_text_length:cardinal;
       panelColor,borderColor,textColor,cursorColor:TVector4f;
       all_text_height:single;
       vertical_slider:PSliderSprite;
       OnFocused,OnTextInput,OnKeyDown:TMemoChangesProc;
     end;

     TListSprite=record
       SpriteType:TSpriteType;
       render_proc:TObjectRenderProc;
       pp:pointer;
       x,y,ch_w,ch_h:single;
       z:byte;
       text:PChar;
       modal:boolean;
       font:PFont;
       text_length:longint;
       text_width,vert_scroll:single;
       dx,dy:single;
       text_color,enabled_text_color,panel_color,
       enabled_panel_color,borderColor:TVector4f;
       texture:PTexture;
       brdWidth,brdHeight:single;
       popup_style,visible:boolean;
       current_item:longint;
       count:cardinal;
       w,h:single;
       vertical_slider:PSliderSprite;
       combo_button:PButtonSprite;
       OnListBoxSelectItem,OnItemEnter:TListChangesProc;
     end;

     TTexture=record
      arrTex:pointer;
      w,h:DWORD;
      blend:boolean;
      filter:TTextureFilter;
      texture_mode:TTextureMode;
      texId:cardinal;
      imageid:cardinal;
      bits:byte;
     end;

     TChunkHead=record
       name:array [0..18] of char;
       compression:TCPUCompressionQuality;
       offset:cardinal;
       size_compr:cardinal;
       size_uncompr:cardinal;
     end;

     TPackFile=record
       chunks_count:cardinal;
       chunks_heads:array of TChunkHead;
       file_handle:longint;
     end;
     PPackFile=^TPackFile;

const {$IFDEF UNIX}
        PhXL='phloxlib.so';
      {$ELSE}
        PhXL='PhloXLib.dll';
      {$ENDIF}

  PHXL_ON_TOP=1;
  PHXL_FULL_SCREEN=2;
  PHXL_HIDE_CURSOR=4;
  PHXL_NOCLEAR_COLOR_BUFFER=8;
  PHXL_CHANGE_SCREEN_RESOLUTION=16;
  PHXL_USE_DEVIL=32;
  PHXL_RESIZABLE_WINDOW=64;
  PHXL_USE_DXINPUT=128;
  PHXL_VSYNC=256;
  PHXL_USE_DEPTHBUFFER=512;
  PHXL_NO_LOGS=1024;
  PHXL_2D_ENABLE=2048;
  PHXL_3D_ENABLE=4096;

  PHXL_DEFAULT=longint($80000000);
  PHXL_KEY_PRESSED=$80;

  PHXL_DEFAULT_SCENE_WIDTH=4.0;
  PHXL_DEFAULT_SCENE_HEIGHT=3.0;

function phxlInit(opt:word;x,y,w,h:integer;capt:pChar):dword;stdcall;external PhXL;
function phxlInit2(opt:word;x,y,w,h:integer;parent:dword):dword;stdcall;external PhXL;
procedure phxlStart;stdcall;external PhXL;
procedure phxlRender;stdcall;external PhXL;
procedure phxlExit;stdcall;external PhXL;
procedure phxlDestroy;stdcall;external PhXL;

procedure phxlSetRenderWindowCoord(x, y, w, h: integer);stdcall;external PhXL;
procedure phxlRenderSkin8(w, h, brdWidth, brdHeight: single);stdcall;external PhXL;
procedure phxlSetZLevels(min_value,count:byte);stdcall;external PhXL;
procedure phxlGetWorldCoord(x, y: Smallint; out xo, yo: single);stdcall;external PhXL;
function phxlGetMainOutPort:POutPort;stdcall;external PhXL;
function phxlGetInputs: PInputs;stdcall;external PhXL;
procedure phxlPause;stdcall;external PhXL;
procedure phxlGetTimes(var time, delta_time: pdword);stdcall;external PhXL;
procedure phxlApplyMainOutPortChanges;stdcall;external PhXL;
function phxlAddOutPort(x, y, w, h: integer; sleep: word): POutPort;stdcall;external PhXL;
procedure phxlDeleteOutPort(op:POutPort);stdcall;external PhXL;
procedure phxlScissorTest(hardware,software:boolean);stdcall;external PhXL;
procedure phxlWriteLogString(str:string;open,close:boolean);stdcall;external PhXL;
function phxlIncludeOpt(opt: word): boolean;stdcall;external PhXL;
function phxlExcludeOpt(opt: word): boolean;stdcall;external PhXL;
procedure phxlSetClearColor(r, g, b: single);stdcall;external PhXL;
procedure phxlSetAlphaTest(at: TAlphaTest);stdcall;external PhXL;
procedure phxlClearLayer(z:byte);stdcall;external PhXL;
procedure phxlClearAllLayers;stdcall;external PhXL;
procedure phxlRegisterProc(proc_type:TPHXLProcType;proc:pointer);stdcall;external PhXL;
function phxlGammaCorrect(const AGamma, ABright, AContrast: Single): Boolean;stdcall;external PhXL;

function phxlAddTimer(tim_proc:TPHXLTimer_proc;time:dword):PPHXLTimer;stdcall;external PhXL;
procedure phxlDeleteTimer(timer:PPHXLTimer);stdcall;external PhXL;

function phxlAddEasySprite(x,y:single;z:byte):PEasySprite;stdcall;external PhXL;
function phxlAddSpriteEx(x,y:single;z:byte):PSpriteEx;stdcall;external PhXL;
function phxlAddAnimSprite(x,y:single;z:byte):PAnimSprite;stdcall;external PhXL;
function phxlAddUserObject(z:byte;user_pr:TObjectRenderProc):PUserObject;stdcall;external PhXL;
function phxlAddSpriteContainer(x,y:single;z:byte;as_gui_form:boolean):PSpriteContainer;stdcall;external PhXL;

function phxlEnableCursor(texture:PTexture;w,h:single):PCursorSprite;stdcall;external PhXL;
function phxlAddTextSprite(text:PChar;z:byte):PTextSprite;stdcall;external PhXL;
function phxlAddButtonSprite(x,y:single;text:PChar;fnt:PFont;ch_w,ch_h:single;z:byte):PButtonSprite;stdcall;external PhXL;
function phxlAddSliderSprite(x, y: single;z:byte): PSliderSprite;stdcall;external PhXL;
function phxlAddMemoSprite(x,y,w,h:single;font:PFont;z:byte):PMemoSprite;stdcall;external PhXL;
function phxlAddListSprite(text:PChar;x,y, brd_w, brd_h, ch_w,ch_h:single; fnt:PFont; z:byte):PListSprite;stdcall;external PhXL;

function phxlAddHaloEffect(parts_count:dword;radius:single;color1,color2:TVector4f;position:TPhXLPoint):PEffect;stdcall;external PhXL name'phxlAddHaloEffect';
function phxlAddFireEffect(radius,particle_radius:single;position,xy_speed:TPhXLPoint;parts_count,interval,life_time:dword):PEffect;stdcall;external PhXL name'phxlAddFireEffect';
function phxlAddFireExEffect(radius,particle_radius:single;position,xy_speed:TPhXLPoint;interval,life_time,frame_count:dword;texture:PTexture):PEffect;stdcall;external PhXL name'phxlAddFireExEffect';
function phxlAddParticles(generate_proc,life_proc:TParticlesProc;particle_radius:single;interval,particle_count,frame_count:dword;texture:PTexture):PEffect;stdcall;external PhXL name'phxlAddParticles';
function phxlAddBlur(blurs_count,interval:dword;scale_speed,start_alpha,end_alpha:single;speed:TPhXLPoint):PEffect;stdcall;external PhXL name'phxlAddBlur';
function phxlAddThor(parts1_cnt,parts2_cnt:byte;glow_alpha,vibration,length_,angle:single;pos:TPhXLPoint;update_interval,elements_count:dword):PEffect;stdcall;external PhXL name'phxlAddThor';
procedure phxlMakeExplode(particles:PEffect;life_time,dlife_time,particle_count:dword;speed,dspeed,scale_speed:single;position:TPhXLPoint);stdcall;external PhXL name'phxlMakeExplode';
procedure phxlDeleteEffect(effect:PEffect);stdcall;external PhXL name'phxlDeleteEffect';
procedure phxlClearEffects;stdcall;external PhXL name'phxlClearEffects';

procedure phxlMakeUserEvents(duration,interval,data:dword;onProgress,onStop:TUserProc);stdcall;external PhXL;
procedure phxlMakeFadeEffect(duration:dword;color1,color2:TVector4f; onStop:TUserProc);stdcall;external PhXL;
procedure phxlMakeShakeEffect(duration,frequency:dword;max_dx,max_dy:single;random:boolean);stdcall;external PhXL;
procedure phxlClearShortEffects;stdcall;external PhXL;

procedure phxlAppendSpriteToContainer(sc:PSpriteContainer;spr:pointer);stdcall;external PhXL;
procedure phxlRemoveSpriteFromContainer(sc:PSpriteContainer;spr:pointer;delete:boolean;z:byte);stdcall;external PhXL;
procedure phxlMoveSpriteContainer(sc: PSpriteContainer;x,y:single);stdcall;external PhXL;//only if gui sprites contained in container. otherwise, directly change x,y properties of container
procedure phxlProportionalImageSprite(spr: PEasySprite;width:boolean);stdcall;external PhXL;
function phxlPointInSprite(spr: PEasySprite; point: TPhXLPoint): boolean;stdcall;external PhXL;
function phxlPointInSphereSprite(spr:PEasySprite;point:TPhXLPoint;radius:single):boolean;stdcall;external PhXL;
function phxlCollideSpritesRects(spr1,spr2:PEasySprite):boolean;stdcall;external PhXL;
function phxlCollideSpritesSpheres(spr1,spr2:PEasySprite;centres_distance:single):boolean;stdcall;external PhXL;
function phxlCollideSpritesSpheres2(spr1,spr2:PEasySprite;centres_distance:single;var vec:TPhXLVector):boolean;stdcall;external PhXL;
procedure phxlSetTextToSprite(text:PChar;spr:PTextSprite; len:longint);stdcall;external PhXL; //len=-1 if not length known
function phxlGetTextSpriteWidth(ts:PTextSprite;text:PChar):single;stdcall;external PhXL;
function phxlGetTextSpriteHeight(ts:PTextSprite;lines_cnt:PCardinal):single;stdcall;external PhXL;
procedure phxlUpdateMemoText(memo:PMemoSprite; newtext:PChar;length,ins_pos:integer;mode:TPHXLTextUpdateMode);stdcall;external PhXL;
procedure phxlUpdateListLines(list: PListSprite; inserted_line: PChar; index: cardinal; mode: TPHXLTextUpdateMode);stdcall;external PhXL;
function phxlGetListLineText(list: PListSprite; index: dword; length: PDWORD ): PChar;stdcall;external PhXL;
procedure phxlGUISelect(gui_obj:pointer);stdcall;external PhXL;
procedure phxlGUIStackMove(gui_obj:pointer;moveto:longint);stdcall;external PhXL;
procedure phxlGUISetModalState(modal:boolean);stdcall;external PhXL;
procedure phxlNotifySprite(spr:PSpriteEx);stdcall;external PhXL;
procedure phxlChangeSpriteLayer(spr:pointer;newz:byte);stdcall;external PhXL;
procedure phxlDeleteSprite(spr:pointer);stdcall;external PhXL;

function phxlLoadFont(fontfilename, texturefilename: PChar):PFont;stdcall;external PhXL name'phxlLoadFont';
function phxlGenFont(height:longint;fontname:PChar; cell_w,cell_h:dword; char_first,char_last,chars_hor,border:word;symbols:boolean):PFont;stdcall;external PhXL name'phxlGenFont';
procedure phxlFreeFont(fnt:PFont);stdcall;external PhXL name'phxlFreeFont';

procedure phxlPrintCaption(text:PChar);stdcall;external PhXL;
function phxlAllocStr(size:integer):PChar;stdcall;external PhXL;
procedure phxlDisposeStr(str:PChar);stdcall;external PhXL;
function phxlIntToStr(int:integer):PChar;stdcall;external PhXL;
function phxlStrToInt(str:PChar):integer;stdcall;external PhXL;
function phxlIntToStr2(int: integer; buf_str: PChar; str_len: cardinal): PChar;stdcall;external PhXL;
function phxlFloatToStr(float: single; buf_str: PChar; str_len: cardinal): PChar;stdcall;external PhXL;
function phxlReadConfig(fn:PChar):boolean;stdcall;external PhXL;
procedure phxlGetConfigString(section,key,outstr,defstr:PChar);stdcall;external PhXL;
function phxlGetConfigInt(section,key:PChar;def:longint):longint;stdcall;external PhXL;
function phxlGetConfigBool(section,key:PChar;def:boolean):boolean;stdcall;external PhXL;
function phxlFlushConfig:boolean;stdcall;external PhXL;

function phxlAddTexture(filename: PChar; filter:TTextureFilter; tex_mode:TTextureMode; compress:TTextureCompressionQuality; blend,free_on_load,mip_maps:boolean):PTexture;stdcall;external PhXL name'phxlAddTexture';
function phxlAddDirectTexture(texture:pointer; size,w,h,bits:dword; filter:TTextureFilter; tex_mode:TTextureMode; compress:TTextureCompressionQuality; blend:boolean):PTexture;stdcall;external PhXL name'phxlAddDirectTexture';
procedure phxlApplyTexture(tex:PTexture);stdcall;external PhXL name'phxlApplyTexture';
procedure phxlUnApplyTexture;stdcall;external PhXL name'phxlUnApplyTexture';
procedure phxlDeleteTexture(tex:PTexture);stdcall;external PhXL name'phxlDeleteTexture';
procedure phxlClearTextures;stdcall;external PhXL name'phxlClearTextures';

function phxlOpenPack(fn:PChar):PPackFile;stdcall;external PhXL name'phxlOpenPack';
function phxlReadChunk(pck:PPackFile; chunk_name:PChar; out size:cardinal):pointer;stdcall;external PhXL name'phxlReadChunk';
function phxlReadTextureChunk(pck:PPackFile; chunk_name:PChar; filter:TTextureFilter; tex_mode:TTextureMode; blend:boolean):PTexture;stdcall;external PhXL name'phxlReadTextureChunk';
procedure phxlClosePack(pck:PPackFile);stdcall;external PhXL name'phxlClosePack';

function phxlCreateVector2f(x,y:single):TVector2f;
function phxlCreateColorVector4f(r,g,b,a:single):TVector4f;
function PHXLPoint(x,y:single):TPhXLPoint;
function PHXLRect2(left,top,right,bottom:single):TPhXLRect2;

implementation

function phxlCreateVector2f(x, y:single): TVector2f;
begin
  result[0]:=x;
  result[1]:=y;
end;

function phxlCreateColorVector4f(r, g, b, a:single): TVector4f;
begin
  result[0]:=r;
  result[1]:=g;
  result[2]:=b;
  result[3]:=a;
end;

function PHXLPoint(x, y: single): TPhXLPoint;
begin
  result.x:=x;
  result.y:=y;
end;

function PHXLRect2(left, top, right, bottom: single): TPhXLRect2;
begin
 result.left:=left;
 result.top:=top;
 result.right:=right;
 result.bottom:=bottom;
end;


end.
