program circles;

{$mode Delphi}
uses
  PhloXLib,GL,SysUtils;

type
  TCircle=record
    x,y:single;
    radius:single;
    color:TVector4f;
    speed:single;
  end;

var
  circles:array [0..49] of TCircle;
  out_port:POutPort;

procedure InitCircles;
var i:integer;
begin
  Randomize;
  for i:=0 to Length(circles)-1 do
  begin
    circles[i].x:=Random*PHXL_DEFAULT_SCENE_WIDTH;
    circles[i].y:=Random*PHXL_DEFAULT_SCENE_HEIGHT;
    circles[i].radius:=Random*0.4;
    circles[i].color:=phxlCreateColorVector4f(Random,Random,Random,circles[i].radius/0.4);
    circles[i].speed:=Random*0.005;
  end;
end;

procedure RenderCircle(var c:TCircle);
var i:integer;
const CIRCLE_QUALITY=40;
begin
  glColor4fv(c.color);
  glBegin(GL_TRIANGLE_FAN);
    glVertex2f(c.x,c.y);
    for i:=0 to CIRCLE_QUALITY do
     glVertex2f(c.x+c.radius*sin(i/CIRCLE_QUALITY*pi*2),c.y+c.radius*cos(i/CIRCLE_QUALITY*pi*2));
  glEnd;
end;

procedure RenderScene(ind:byte);stdcall;
var i:integer;
begin
  for i:=0 to Length(circles)-1 do
  begin
    RenderCircle(circles[i]);
    circles[i].y:=circles[i].y-circles[i].speed*out_port.delta_time;
    if circles[i].y<-circles[i].radius then circles[i].y:=PHXL_DEFAULT_SCENE_HEIGHT+circles[i].radius;
  end;
end;

procedure Timer(delta_time:cardinal);stdcall;
begin
  phxlPrintCaption(PChar('Circles demko! FPS='+IntToStr(out_port.fps)));
end;

begin
  phxlInit(PHXL_2D_ENABLE,0,0,800,600,nil);
  phxlRegisterProc(ptRender_proc,@RenderScene);
  phxlAddTimer(@Timer,1000);
  phxlSetClearColor(0.5,0.0,0.0);
  glEnable(GL_BLEND);
  out_port:=phxlGetMainOutPort;
  InitCircles;
  phxlStart;
end.

