unit VirtualKeys;
{$I phxldefs.inc}
{$mode objfpc}{$H+}
{$IFDEF WINDOWS}
  {$IFDEF UseDirectX}
     {$DEFINE D}{$ELSE}
     {$DEFINE W}
  {$ENDIF}
{$ENDIF}

{$IFDEF UNIX}
  {$DEFINE X}
{$ENDIF}

interface

const
     VK_LBUTTON = {$IFDEF W} 1 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} 0 {$ENDIF};
     VK_RBUTTON = {$IFDEF W} 2 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} 0 {$ENDIF};
     VK_CANCEL = {$IFDEF W} 3 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} 0 {$ENDIF};
     VK_MBUTTON = {$IFDEF W} 4 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} 0 {$ENDIF};
     VK_BACK = {$IFDEF W} 8 {$ENDIF}{$IFDEF D} $0E {$ENDIF}{$IFDEF X} $08 {$ENDIF};
     VK_TAB = {$IFDEF W} 9 {$ENDIF}{$IFDEF D} $0F {$ENDIF}{$IFDEF X} $09 {$ENDIF};
     VK_CLEAR = {$IFDEF W} 12 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $0B {$ENDIF};
     VK_RETURN = {$IFDEF W} 13 {$ENDIF}{$IFDEF D} $1C {$ENDIF}{$IFDEF X} $0D {$ENDIF}; (* Enter on main keyboard *)
     VK_SHIFT = {$IFDEF W} 16 {$ENDIF}{$IFDEF D} $2A {$ENDIF}{$IFDEF X} $E1 {$ENDIF}; (* left Shift *)
     VK_CONTROL = {$IFDEF W} 17 {$ENDIF}{$IFDEF D} $1D {$ENDIF}{$IFDEF X} $E3 {$ENDIF}; (* left Ctrl *)
     VK_MENU = {$IFDEF W} 18 {$ENDIF}{$IFDEF D} $38 {$ENDIF}{$IFDEF X} $E9 {$ENDIF}; (* left Alt *)
     VK_RSHIFT = {$IFDEF W} 16 {$ENDIF}{$IFDEF D} $36 {$ENDIF}{$IFDEF X} $E2 {$ENDIF}; (* right Shift *)
     VK_RCONTROL = {$IFDEF W} 17 {$ENDIF}{$IFDEF D} $9D {$ENDIF}{$IFDEF X} $E4 {$ENDIF}; (* right Ctrl *)
     VK_RMENU = {$IFDEF W} 18 {$ENDIF}{$IFDEF D} $B8 {$ENDIF}{$IFDEF X} $EA {$ENDIF}; (* right Alt *)
     VK_PAUSE = {$IFDEF W} 19 {$ENDIF}{$IFDEF D} $C5 {$ENDIF}{$IFDEF X} $13 {$ENDIF};
     VK_CAPITAL = {$IFDEF W} 20 {$ENDIF}{$IFDEF D} $3A {$ENDIF}{$IFDEF X} $E5 {$ENDIF}; (*Caps Lock*)
     VK_ESCAPE = {$IFDEF W} 27 {$ENDIF}{$IFDEF D} $01 {$ENDIF}{$IFDEF X} $1B {$ENDIF};
     VK_SPACE = {$IFDEF W} 32 {$ENDIF}{$IFDEF D} $39 {$ENDIF}{$IFDEF X} $020 {$ENDIF};
     
     VK_PRIOR = {$IFDEF W} 33 {$ENDIF}{$IFDEF D} $C9 {$ENDIF}{$IFDEF X} $55 {$ENDIF};(* PgUp on arrow keypad *)
     VK_NEXT = {$IFDEF W} 34 {$ENDIF}{$IFDEF D} $D1 {$ENDIF}{$IFDEF X} $56 {$ENDIF};(* PgDn on arrow keypad *)
     VK_END = {$IFDEF W} 35 {$ENDIF}{$IFDEF D} $CF {$ENDIF}{$IFDEF X} $57 {$ENDIF};
     VK_HOME = {$IFDEF W} 36 {$ENDIF}{$IFDEF D} $C7 {$ENDIF}{$IFDEF X} $50 {$ENDIF};
     VK_LEFT = {$IFDEF W} 37 {$ENDIF}{$IFDEF D} $CB {$ENDIF}{$IFDEF X} $51 {$ENDIF};
     VK_UP = {$IFDEF W} 38 {$ENDIF}{$IFDEF D} $C8 {$ENDIF}{$IFDEF X} $52 {$ENDIF};
     VK_RIGHT = {$IFDEF W} 39 {$ENDIF}{$IFDEF D} $CD {$ENDIF}{$IFDEF X} $53 {$ENDIF};
     VK_DOWN = {$IFDEF W} 40 {$ENDIF}{$IFDEF D} $D0 {$ENDIF}{$IFDEF X} $54 {$ENDIF};
     VK_SELECT = {$IFDEF W} 41 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $60 {$ENDIF};
     VK_PRINT = {$IFDEF W} 42 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $61 {$ENDIF};
     VK_EXECUTE = {$IFDEF W} 43 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $62 {$ENDIF};
     VK_SNAPSHOT = {$IFDEF W} 44 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} 0 {$ENDIF};
     VK_INSERT = {$IFDEF W} 45 {$ENDIF}{$IFDEF D} $D2 {$ENDIF}{$IFDEF X} $63 {$ENDIF};
     VK_DELETE = {$IFDEF W} 46 {$ENDIF}{$IFDEF D} $D3 {$ENDIF}{$IFDEF X} $FF {$ENDIF};
     VK_HELP = {$IFDEF W} 47 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $6A {$ENDIF};
     
     VK_0 = {$IFDEF W} 48 {$ENDIF}{$IFDEF D} $0B {$ENDIF}{$IFDEF X} $30 {$ENDIF};
     VK_1 = {$IFDEF W} 49 {$ENDIF}{$IFDEF D} $02 {$ENDIF}{$IFDEF X} $31 {$ENDIF};
     VK_2 = {$IFDEF W} 50 {$ENDIF}{$IFDEF D} $03 {$ENDIF}{$IFDEF X} $32 {$ENDIF};
     VK_3 = {$IFDEF W} 51 {$ENDIF}{$IFDEF D} $04 {$ENDIF}{$IFDEF X} $33 {$ENDIF};
     VK_4 = {$IFDEF W} 52 {$ENDIF}{$IFDEF D} $05 {$ENDIF}{$IFDEF X} $34 {$ENDIF};
     VK_5 = {$IFDEF W} 53 {$ENDIF}{$IFDEF D} $06 {$ENDIF}{$IFDEF X} $35 {$ENDIF};
     VK_6 = {$IFDEF W} 54 {$ENDIF}{$IFDEF D} $07 {$ENDIF}{$IFDEF X} $36 {$ENDIF};
     VK_7 = {$IFDEF W} 55 {$ENDIF}{$IFDEF D} $08 {$ENDIF}{$IFDEF X} $37 {$ENDIF};
     VK_8 = {$IFDEF W} 56 {$ENDIF}{$IFDEF D} $09 {$ENDIF}{$IFDEF X} $38 {$ENDIF};
     VK_9 = {$IFDEF W} 57 {$ENDIF}{$IFDEF D} $0A {$ENDIF}{$IFDEF X} $39 {$ENDIF};

     VK_A = {$IFDEF W} 65 {$ENDIF}{$IFDEF D} $1E {$ENDIF}{$IFDEF X} 97 {$ENDIF};
     VK_B = {$IFDEF W} 66 {$ENDIF}{$IFDEF D} $30 {$ENDIF}{$IFDEF X} 98 {$ENDIF};
     VK_C = {$IFDEF W} 67 {$ENDIF}{$IFDEF D} $2E {$ENDIF}{$IFDEF X} 99 {$ENDIF};
     VK_D = {$IFDEF W} 68 {$ENDIF}{$IFDEF D} $20 {$ENDIF}{$IFDEF X} 100 {$ENDIF};
     VK_E = {$IFDEF W} 69 {$ENDIF}{$IFDEF D} $12 {$ENDIF}{$IFDEF X} 101 {$ENDIF};
     VK_F = {$IFDEF W} 70 {$ENDIF}{$IFDEF D} $21 {$ENDIF}{$IFDEF X} 102 {$ENDIF};
     VK_G = {$IFDEF W} 71 {$ENDIF}{$IFDEF D} $22 {$ENDIF}{$IFDEF X} 103 {$ENDIF};
     VK_H = {$IFDEF W} 72 {$ENDIF}{$IFDEF D} $23 {$ENDIF}{$IFDEF X} 104 {$ENDIF};
     VK_I = {$IFDEF W} 73 {$ENDIF}{$IFDEF D} $17 {$ENDIF}{$IFDEF X} 105 {$ENDIF};
     VK_J = {$IFDEF W} 74 {$ENDIF}{$IFDEF D} $24 {$ENDIF}{$IFDEF X} 106 {$ENDIF};
     VK_K = {$IFDEF W} 75 {$ENDIF}{$IFDEF D} $25 {$ENDIF}{$IFDEF X} 107 {$ENDIF};
     VK_L = {$IFDEF W} 76 {$ENDIF}{$IFDEF D} $26 {$ENDIF}{$IFDEF X} 108 {$ENDIF};
     VK_M = {$IFDEF W} 77 {$ENDIF}{$IFDEF D} $32 {$ENDIF}{$IFDEF X} 109 {$ENDIF};
     VK_N = {$IFDEF W} 78 {$ENDIF}{$IFDEF D} $31 {$ENDIF}{$IFDEF X} 110 {$ENDIF};
     VK_O = {$IFDEF W} 79 {$ENDIF}{$IFDEF D} $18 {$ENDIF}{$IFDEF X} 111 {$ENDIF};
     VK_P = {$IFDEF W} 80 {$ENDIF}{$IFDEF D} $19 {$ENDIF}{$IFDEF X} 112 {$ENDIF};
     VK_Q = {$IFDEF W} 81 {$ENDIF}{$IFDEF D} $10 {$ENDIF}{$IFDEF X} 113 {$ENDIF};
     VK_R = {$IFDEF W} 82 {$ENDIF}{$IFDEF D} $13 {$ENDIF}{$IFDEF X} 114 {$ENDIF};
     VK_S = {$IFDEF W} 83 {$ENDIF}{$IFDEF D} $1F {$ENDIF}{$IFDEF X} 115 {$ENDIF};
     VK_T = {$IFDEF W} 84 {$ENDIF}{$IFDEF D} $14 {$ENDIF}{$IFDEF X} 116 {$ENDIF};
     VK_U = {$IFDEF W} 85 {$ENDIF}{$IFDEF D} $16 {$ENDIF}{$IFDEF X} 117 {$ENDIF};
     VK_V = {$IFDEF W} 86 {$ENDIF}{$IFDEF D} $2F {$ENDIF}{$IFDEF X} 118 {$ENDIF};
     VK_W = {$IFDEF W} 87 {$ENDIF}{$IFDEF D} $11 {$ENDIF}{$IFDEF X} 119 {$ENDIF};
     VK_X = {$IFDEF W} 88 {$ENDIF}{$IFDEF D} $2D {$ENDIF}{$IFDEF X} 120 {$ENDIF};
     VK_Y = {$IFDEF W} 89 {$ENDIF}{$IFDEF D} $15 {$ENDIF}{$IFDEF X} 121 {$ENDIF};
     VK_Z = {$IFDEF W} 90 {$ENDIF}{$IFDEF D} $2C {$ENDIF}{$IFDEF X} 122 {$ENDIF};

     VK_LWIN = {$IFDEF W} 91 {$ENDIF}{$IFDEF D} $DB {$ENDIF}{$IFDEF X} $EB {$ENDIF};
     VK_RWIN = {$IFDEF W} 92 {$ENDIF}{$IFDEF D} $DC {$ENDIF}{$IFDEF X} $EC {$ENDIF};
     VK_APPS = {$IFDEF W} 93 {$ENDIF}{$IFDEF D} $DD {$ENDIF}{$IFDEF X} $67 {$ENDIF};

     VK_NUMPAD0 = {$IFDEF W} 96 {$ENDIF}{$IFDEF D} $52 {$ENDIF}{$IFDEF X} $9E {$ENDIF};
     VK_NUMPAD1 = {$IFDEF W} 97 {$ENDIF}{$IFDEF D} $4F {$ENDIF}{$IFDEF X} $9C {$ENDIF};
     VK_NUMPAD2 = {$IFDEF W} 98 {$ENDIF}{$IFDEF D} $50 {$ENDIF}{$IFDEF X} $99 {$ENDIF};
     VK_NUMPAD3 = {$IFDEF W} 99 {$ENDIF}{$IFDEF D} $51 {$ENDIF}{$IFDEF X} $9B {$ENDIF};
     VK_NUMPAD4 = {$IFDEF W} 100 {$ENDIF}{$IFDEF D} $4B {$ENDIF}{$IFDEF X} $96 {$ENDIF};
     VK_NUMPAD5 = {$IFDEF W} 101 {$ENDIF}{$IFDEF D} $4C {$ENDIF}{$IFDEF X} $B5 {$ENDIF};
     VK_NUMPAD6 = {$IFDEF W} 102 {$ENDIF}{$IFDEF D} $4D {$ENDIF}{$IFDEF X} $98 {$ENDIF};
     VK_NUMPAD7 = {$IFDEF W} 103 {$ENDIF}{$IFDEF D} $47 {$ENDIF}{$IFDEF X} $95 {$ENDIF};
     VK_NUMPAD8 = {$IFDEF W} 104 {$ENDIF}{$IFDEF D} $48 {$ENDIF}{$IFDEF X} $97 {$ENDIF};
     VK_NUMPAD9 = {$IFDEF W} 105 {$ENDIF}{$IFDEF D} $49 {$ENDIF}{$IFDEF X} $9A {$ENDIF};
     
     VK_MULTIPLY = {$IFDEF W} 106 {$ENDIF}{$IFDEF D} $37 {$ENDIF}{$IFDEF X} $AA {$ENDIF};(* * on numeric keypad *)
     VK_ADD = {$IFDEF W} 107 {$ENDIF}{$IFDEF D} $4E {$ENDIF}{$IFDEF X} $AB {$ENDIF};(* + on numeric keypad *)
     VK_SEPARATOR = {$IFDEF W} 108 {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $AC {$ENDIF};
     VK_SUBTRACT = {$IFDEF W} 109 {$ENDIF}{$IFDEF D} $4A {$ENDIF}{$IFDEF X} $AD {$ENDIF};(* - on numeric keypad *)
     VK_DECIMAL = {$IFDEF W} 110 {$ENDIF}{$IFDEF D} $53 {$ENDIF}{$IFDEF X} $AE {$ENDIF};(* . on numeric keypad *)
     VK_DIVIDE = {$IFDEF W} 111 {$ENDIF}{$IFDEF D} $B5 {$ENDIF}{$IFDEF X} $AF {$ENDIF};(* / on numeric keypad *)
     VK_NUM_DELETE = {$IFDEF W} VK_DELETE {$ENDIF}{$IFDEF D} 0 {$ENDIF}{$IFDEF X} $9F {$ENDIF};
     VK_NUMPADENTER = {$IFDEF W} VK_RETURN {$ENDIF}{$IFDEF D} $9C {$ENDIF}{$IFDEF X} $8D {$ENDIF}; (* Enter on numeric keypad *)
     
     VK_F1 = {$IFDEF W} 112 {$ENDIF}{$IFDEF D} $3B {$ENDIF}{$IFDEF X} $BE {$ENDIF};
     VK_F2 = {$IFDEF W} 113 {$ENDIF}{$IFDEF D} $3C {$ENDIF}{$IFDEF X} $BF {$ENDIF};
     VK_F3 = {$IFDEF W} 114 {$ENDIF}{$IFDEF D} $3D {$ENDIF}{$IFDEF X} $C0 {$ENDIF};
     VK_F4 = {$IFDEF W} 115 {$ENDIF}{$IFDEF D} $3E {$ENDIF}{$IFDEF X} $C1 {$ENDIF};
     VK_F5 = {$IFDEF W} 116 {$ENDIF}{$IFDEF D} $3F {$ENDIF}{$IFDEF X} $C2 {$ENDIF};
     VK_F6 = {$IFDEF W} 117 {$ENDIF}{$IFDEF D} $40 {$ENDIF}{$IFDEF X} $C3 {$ENDIF};
     VK_F7 = {$IFDEF W} 118 {$ENDIF}{$IFDEF D} $41 {$ENDIF}{$IFDEF X} $C4 {$ENDIF};
     VK_F8 = {$IFDEF W} 119 {$ENDIF}{$IFDEF D} $42 {$ENDIF}{$IFDEF X} $C5 {$ENDIF};
     VK_F9 = {$IFDEF W} 120 {$ENDIF}{$IFDEF D} $43 {$ENDIF}{$IFDEF X} $C6 {$ENDIF};
     VK_F10 = {$IFDEF W} 121 {$ENDIF}{$IFDEF D} $44 {$ENDIF}{$IFDEF X} $C7 {$ENDIF};
     VK_F11 = {$IFDEF W} 122 {$ENDIF}{$IFDEF D} $57 {$ENDIF}{$IFDEF X} $C8 {$ENDIF};

     VK_NUMLOCK = {$IFDEF W} 145 {$ENDIF}{$IFDEF D} $45 {$ENDIF}{$IFDEF X} $7F {$ENDIF};
     VK_SCROLL = {$IFDEF W} 145 {$ENDIF}{$IFDEF D} $46 {$ENDIF}{$IFDEF X} $14 {$ENDIF};

implementation

end.

